datablock AudioProfile(FNSCAR1Sound)
{
   filename    = "./FNSCAR_Fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(FNSCARClipInSound)
{
   filename    = "./FNSCAR_ClipIn.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(FNSCARClipOutSound)
{
   filename    = "./FNSCAR_ClipOut.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(FNSCARUseSound)
{
   filename    = "./M16_Use.wav";
   description = AudioClose3d;
   preload = true;
};

AddDamageType("FNSCAR",   '<bitmap:add-ons/Weapon_L4D2/CI_SCAR> %1',    '%2 <bitmap:add-ons/Weapon_L4D2/CI_SCAR> %1',0.2,1);
datablock ProjectileData(FNSCARProjectile)
{
   projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 44;
   directDamageType    = $DamageType::FNSCAR;
   radiusDamageType    = $DamageType::FNSCAR;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   explosion           = gunExplosion;

   muzzleVelocity      = 75;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.2;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Combat Rifle Bullet";
};

//////////
// item //
//////////
datablock ItemData(FNSCARItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./FNSCARPU.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "FN-Scar";
	iconName = "./UI_SCAR";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = FNSCARImage;
	canDrop = true;

	maxAmmo = 60;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(FNSCARImage)
{
   // Basic Item properties
   shapeFile = "./FNSCAR.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = FNSCARItem;
   ammo = " ";
   projectile = FNSCARProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = FNSCARItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.73;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	stateSound[0]				= FNSCARUseSound;
	stateSequence[0]			= "use";

	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateAllowImageChange[1]         	= true;

	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Fire2";
	stateTimeoutValue[2]            	= 0.06;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "Fire";
	stateScript[2]                  	= "onFire";
	stateEjectShell[2]       	  	= true;
	stateEmitter[2]				= gunFlashEmitter;
	stateEmitterTime[2]			= 0.05;
	stateEmitterNode[2]			= "muzzleNode";
	stateWaitForTimeout[2]			= true;
	stateSound[2]				= FNSCAR1Sound;

	stateName[3]                    	= "Fire2";
	stateTransitionOnTimeout[3]     	= "Fire3";
	stateTimeoutValue[3]            	= 0.06;
	stateFire[3]                    	= true;
	stateAllowImageChange[3]        	= false;
	stateSequence[3]                	= "Fire";
	stateScript[3]                  	= "onFire";
	stateEjectShell[3]       	  	= true;
	stateEmitter[3]				= gunFlashEmitter;
	stateEmitterTime[3]			= 0.05;
	stateEmitterNode[3]			= "muzzleNode";
	stateWaitForTimeout[3]			= true;
	stateSound[3]				= FNSCAR1Sound;

	stateName[4]                    	= "Fire3";
	stateTransitionOnTimeout[4]     	= "Delay";
	stateTimeoutValue[4]            	= 0.1;
	stateFire[4]                    	= true;
	stateAllowImageChange[4]        	= false;
	stateSequence[4]                	= "Fire";
	stateScript[4]                  	= "onFire";
	stateEjectShell[4]       	  	= true;
	stateEmitter[4]				= gunFlashEmitter;
	stateEmitterTime[4]			= 0.05;
	stateEmitterNode[4]			= "muzzleNode";
	stateWaitForTimeout[4]			= true;
	stateSound[4]				= FNSCAR1Sound;

	stateName[5]				= "Delay";
	stateTransitionOnTimeout[5]     	= "FireLoadCheckA";
	stateTimeoutValue[5]            	= 0.06;
	stateEmitter[5]				= gunSmokeEmitter;
	stateEmitterTime[5]			= 0.07;
	stateEmitterNode[5]			= "muzzleNode";
	
	stateName[6]				= "LoadCheckA";
	stateScript[6]				= "onLoadCheck";
	stateTimeoutValue[6]			= 0.01;
	stateTransitionOnTimeout[6]		= "LoadCheckB";
	
	stateName[7]				= "LoadCheckB";
	stateTransitionOnAmmo[7]		= "Ready";
	stateTransitionOnNoAmmo[7]		= "Reload";

	stateName[8]				= "Reload";
	stateTimeoutValue[8]			= 0.96;
	stateScript[8]				= "onReloadStart";
	stateTransitionOnTimeout[8]		= "Wait";
	stateWaitForTimeout[8]			= true;
	stateSequence[8]			= "reload1";
	stateSound[8]				= FNSCARClipOutSound;
	
	stateName[9]				= "Wait";
	stateTimeoutValue[9]			= 1.31;
	stateSound[9]				= FNSCARClipInSound;
	stateScript[9]				= "onReloadWait";
	stateSequence[9]			= "reload2";
	stateTransitionOnTimeout[9]		= "Reloaded";
	
	stateName[10]				= "FireLoadCheckA";
	stateScript[10]				= "onLoadCheck";
	stateTimeoutValue[10]			= 0.01;
	stateTransitionOnTimeout[10]		= "FireLoadCheckB";
	
	stateName[11]				= "FireLoadCheckB";
	stateTransitionOnAmmo[11]		= "Smoke";
	stateTransitionOnNoAmmo[11]		= "ReloadSmoke";
	
	stateName[12] 				= "Smoke";
	stateEmitter[12]			= gunSmokeEmitter;
	stateEmitterTime[12]			= 0.3;
	stateEmitterNode[12]			= "muzzleNode";
	stateTimeoutValue[12]			= 0.4;
	stateTransitionOnTimeout[12]		= "Ready";
	stateTransitionOnTriggerDown[12]	= "Fire";
	
	stateName[13] 				= "ReloadSmoke";
	stateEmitter[13]			= gunSmokeEmitter;
	stateEmitterTime[13]			= 0.3;
	stateEmitterNode[13]			= "muzzleNode";
	stateTimeoutValue[13]			= 0.2;
	stateTransitionOnTimeout[13]		= "Reload";
	
	stateName[14]				= "Reloaded";
	stateTimeoutValue[14]			= 0.01;
	stateScript[14]				= "onReloaded";
	stateTransitionOnTimeout[14]		= "Ready";
};

function FNSCARImage::onFire(%this,%obj,%slot)
{
	%projectile = FNSCARProjectile;

	if(vectorLen(%obj.getVelocity()) < 0.1)
	{
		%spread = 0.00125;
	}
	else
	{
		%spread = 0.00145;
	}
	
	%obj.lastShotTime = getSimTime();
	%shellcount = 1;

	%obj.playThread(2, plant);
	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}


function FNSCARImage::onMount(%this, %obj, %slot)
{	
	%obj.hidenode("RHand");
        %obj.hidenode("LHand");
}


function FNSCARImage::onUnMount(%this, %obj, %slot)
{	
	%obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
}

function FNSCARImage::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function FNSCARImage::onReloadStart(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = 0;
}

function FNSCARImage::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = 60;
	%obj.setImageAmmo(%slot,1);
}